﻿package 
{
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.*;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	

	public class Fourmiz extends Sprite
	{
		private var o:Array;
		private var misterD=new Array("0x587b7C","0x719b9E","0x9FC1BE","0xE0D9BB","0xDACB94","0xCABA88","0xDABD55","0xC49F32","0xA97409");
		private var misterDbis=new Array("0x111122","0x333344","0x444455","0x555566");
		//private var fourmis=new Array("0x587b7C","0x719b9E","0x9FC1BE","0xE0D9BB","0xDACB94","0xCABA88","0xDABD55","0xC49F32","0xA97409");
		private var i:Number=0;
		private var color:uint;
		private var vario:Number;
		private var posx:Number;
		private var posy:Number;
		private var randX:Number;
		private var randY:Number;
		private var Pi:Number;
		private var negpos:Number; 
		private var enlarge:Number; 
		
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		
		
		public function Fourmiz()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			doubleClickEnabled=true;
			addEventListener(MouseEvent.DOUBLE_CLICK, erase);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);			
			data = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x587b7C);
			background = new Bitmap(data);
			addChild(background);
			drawer = new Sprite();
		}
		
		private function erase(e:MouseEvent):void
		{
			var rect:Rectangle=new Rectangle(0,0,stage.stageWidth,stage.stageHeight);
			data.fillRect(rect, misterD[Math.floor(Math.random()*misterD.length)]);
		}
		
		
		
		private function clickHandler(e:MouseEvent):void 
		{
			negpos = Math.ceil((Math.random()*4));
			randX = .2+Math.random()*negpos/5;
			randY = .2+Math.random()*negpos/5;
			enlarge=0;

			o = new Array();
			
			Pi = .5+Math.random()*(Math.PI-.1);
			i = 0;
			posx = mouseX;
			posy = mouseY;
			addEventListener(Event.ENTER_FRAME, draw);
			
			//data.fillRect(rect, 0x587b7C);
			
			color = misterDbis[Math.floor(Math.random()*misterDbis.length)]
		}
		
		private function draw(e:Event):void
		{
			//vario++;
			drawer.graphics.clear();
			
			o[i++] = [posx,posy,randX*Math.random(),randY*Math.random(), Math.random()*1, Math.random()*.4];
			//trace(i);
			for each(var p in o)
			{
				//enlarge += .0001;
				drawer.graphics.lineStyle(p[4],color,p[5]);
				drawer.graphics.moveTo(p[0],p[1]);
				
				if(negpos == 1){
					drawer.graphics.lineTo(p[0]-=Math.cos((p[1]*p[2]*p[3]*Math.PI/(3600/stage.stageWidth))),p[1]-=Math.cos(p[0]*p[2]*p[3]/Math.PI/(Pi)));
					}
				if(negpos == 2){
					drawer.graphics.lineTo(p[0]-=Math.cos((p[1]*p[2]*p[3]*Math.PI/(3600/stage.stageWidth))),p[1]+=Math.cos(p[0]*p[2]*p[3]/Math.PI/(Pi/2)));
					}
				if(negpos == 3){
					drawer.graphics.lineTo(p[0]+=Math.cos((p[1]*p[2]*p[3]*Math.PI/(3600/stage.stageWidth))),p[1]-=Math.cos(p[0]*p[2]*p[3]/Math.PI/(Pi/2)));
					}
				if(negpos == 4){
					drawer.graphics.lineTo(p[0]+=Math.cos((p[1]*p[2]*p[3]*Math.PI/(3600/stage.stageWidth))),p[1]+=Math.cos(p[0]*p[2]*p[3]/Math.PI/(Pi)));
					}
				
				//trace(Math.cos((p[1]*p[2]*p[3]*Math.PI/(3600/stage.stageWidth))));
				//trace();
			}
			i +=Math.random()*500;
			data.draw(drawer);
			
		}	
		
	}
}